﻿using LibOfdCreatorParam;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WpfInvoiceClient
{
    /// <summary>
    /// 生成结婚证数据，发送到服务端
    /// </summary>
    class MarriageCertCreator
    {
        string TemplateGuid = "5041075d-a3d3-462e-b4b2-c3a9cfb18c8d";
        public WebClientInputParam Creat()
        {
            WebClientInputParam clientParam = new WebClientInputParam();
            clientParam.TemplateGuid = TemplateGuid;
            clientParam.ClientData = "客户端发送的tag数据";

            clientParam.PageGroup = new List<WebClientPage>();

            WebClientPage page = CreateFirstPage();
            clientParam.PageGroup.Add(page);

            return clientParam;
        }

        string _qrFilePath = "./结婚证二维码.png";
        string _photoFilePath = "./结婚证合影.png";
        private WebClientPage CreateFirstPage()
        {
            WebClientPage page = new WebClientPage();
            page.TemplatePageIndex = 0;//对于模版文件oft的第一页

            //持证人
            WebClientTextItem item = new WebClientTextItem()
            { Guid = "*5", DataValue = "周呜呜" };
            page.ListPageText.Add(item);

            //登记日期
            item = new WebClientTextItem()
            { Guid = "*7", DataValue = DateTime.Now.ToString("yyyy-MM-dd") };
            page.ListPageText.Add(item);

            //结婚证字号
            item = new WebClientTextItem()
            { Guid = "*9", DataValue = "J330302-2020-1234567" };
            page.ListPageText.Add(item);

            //备注
            item = new WebClientTextItem()
            { Guid = "*11", DataValue = "民政厅颁发的电子证照,与纸质证照有同等法律效力。" };
            page.ListPageText.Add(item);

            //男方姓名
            item = new WebClientTextItem()
            { Guid = "*15", DataValue = "张一三" };
            page.ListPageText.Add(item);

            //男方国籍
            item = new WebClientTextItem()
            { Guid = "*17", DataValue = "中国籍" };
            page.ListPageText.Add(item);

            //男方出生日期
            item = new WebClientTextItem()
            { Guid = "*19", DataValue = "1998-09-08" };
            page.ListPageText.Add(item);

            //男方身份证号
            item = new WebClientTextItem()
            { Guid = "*21", DataValue = "3700000000002020" };
            page.ListPageText.Add(item);

            //女方姓名
            item = new WebClientTextItem()
            { Guid = "*23", DataValue = "李二四" };
            page.ListPageText.Add(item);

            //女方国籍
            item = new WebClientTextItem()
            { Guid = "*25", DataValue = "韩国" };
            page.ListPageText.Add(item);

            //女方出生日期
            item = new WebClientTextItem()
            { Guid = "*27", DataValue = "1999-12-02" };
            page.ListPageText.Add(item);

            //女方身份证号
            item = new WebClientTextItem()
            { Guid = "*29", DataValue = "49000000001999" };
            page.ListPageText.Add(item);

            /*********************图片数据*********************/

            //二维码
            if (File.Exists(_qrFilePath))
            {
                string imageData = Convert.ToBase64String(File.ReadAllBytes(_qrFilePath));
                WebClientImageItem image = new WebClientImageItem();
                image.Guid = "*31";
                image.DataValue = imageData;
                page.ListPageImage.Add(image);
            }

            //合影照片
            if (File.Exists(_photoFilePath))
            {
                string imageData = Convert.ToBase64String(File.ReadAllBytes(_photoFilePath));
                WebClientImageItem image = new WebClientImageItem();
                image.Guid = "*13";
                image.DataValue = imageData;
                page.ListPageImage.Add(image);
            }
        
            return page;
        }
    }
}
