﻿using System.Collections.Generic;

namespace LibOfdCreatorParam
{
    /************客户端与服务端接口类型定义****************/


    //发送到服务端类型定义
    public class WebClientInputParam
    {
        //客户端数据，服务端会原样返回
        public string ClientData { get; set; }
        //模板id
        public string TemplateGuid { get; set; }

        public List<WebClientPage> PageGroup { get; set; }
    }

    public class WebClientPage
    {
        //模板对应的页面索引值。从0开始；
        public int TemplatePageIndex { get; set; }
        //模板中文字参数
        public List<WebClientTextItem> ListPageText { get; set; } = new List<WebClientTextItem>();
        //模板中图片参数
        public List<WebClientImageItem> ListPageImage { get; set; } = new List<WebClientImageItem>();
    }

    public class WebClientTextItem
    {
        //该值的索引。从0开始。如果为大于0，根据模板设定偏移；
        public int ItemIndex { get; set; }

        //在模板设定的位置基础上，施加的偏移量
        public float OffsetX { get; set; }
        public float OffsetY { get; set; }

        public string Guid { get; set; }            //参数id
        public string Name_CN { get; set; }         //中文名
        public string Define { get; set; }          //定义
        public string Name_EN { get; set; }         //英文名
        public string ShortName { get; set; }       //短名
        public string DataValue { get; set; }       //值
    }

    public class WebClientImageItem
    {
        public string Guid { get; set; }
        public string Name_CN { get; set; }     //中文名
        public string Define { get; set; }      //定义
        public string Name_EN { get; set; }     //英文名
        public string ShortName { get; set; }       //短名
        //为base64格式图片数据
        public string DataValue { get; set; }       //值
        //为文件后缀名，如".png",".jpg";
        public string ImageExt { get; set; }
    }

    public enum EN_WebClientDataType
    {
        文本,
        图片
    }

    //从服务端返回的类型定义
    public class WebClientOutputParam
    {
        public bool OK { get; set; }            //是否成功
        public string Message { get; set; }     //提示信息
        public string OfdDocId { get; set; }    //每个ofd文档会有一个guid
        public string OfdFileDataBase64 { get; set; }   //ofd文件数据

        //客户端数据，服务端原样返回
        public string ClientData { get; set; }
        //服务端返回的其它数据，扩展使用
        public string ServerData { get; set; }
    }
}
